import socket

IP = '127.0.0.1'
PORT = 1728
LenOfMessage = 3  # The protocol for sending messages which length is unknown
# All messages like this will have three digits before them
# The digits indicate the length of the message
# For example, '{:0>3}'.format(str(len(message))) + message


def main():
    """
    Establishes connection with a server
    Sends the server different tasks and receives output
    """
    my_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    try:  # Tries to connect to the server
        my_socket.connect((IP, PORT))
        flag = True
    except:
        print("Server isn't running")
        flag = False
    if flag:
        data = my_socket.recv(LenOfMessage)
        print(my_socket.recv(int(data)))
        func = ""
        while func != "EXIT":
            func = raw_input("Enter a function:\n"  # Gets input from the user
                             "'picture' for screenshot\n"
                             "'directory' for accessing a directory\n"
                             "'delete' for deleting a file\n"
                             "'copy' for copying a file to another file\n"
                             "'open' for opening a program\n"
                             "'exit' to exit the server\n").upper()
            if func:  # Checks if the input wasn't just 'enter'
                my_socket.send('{:0>3}'.format(str(len(func))) + func)
                if func == "PICTURE":
                    # Receives the encoded screenshot 1000 characters at a time
                    # Stops when the end of the message is " ENDING"
                    # Decodes the message and saves the picture
                    pic = ""
                    data = my_socket.recv(1000)
                    while data[-7:] != " ENDING":
                        pic += data
                        data = my_socket.recv(1000)
                    pic += data[:-7]
                    with open("ClientScreen.png",
                              "wb") as fh:
                        fh.write(pic.decode('base64'))
                elif func == "DIRECTORY":
                    # Gets a directory from the user and sends it
                    # Gets a message from the server if the directory exists
                    # Receives the number of files in it
                    # Receives the files and prints them
                    directory = raw_input("What directory would you like to"
                                          " inspect? (include full path)\n")
                    if directory:  # Checks if the input wasn't just 'enter'
                        directory = directory.replace("\\", "\\\\")
                        my_socket.send('{:0>3}'.format(str(len(directory))) +
                                       directory)
                        isdir = my_socket.recv(6)  # protocol for the message
                        if isdir == "yesdir":
                            print("The files inside it are:")
                            num = my_socket.recv(LenOfMessage)
                            for i in xrange(0, int(num)):
                                length = my_socket.recv(LenOfMessage)
                                print(my_socket.recv(int(length)))
                        else:
                            print("Not a valid directory")
                    else:
                        my_socket.send("007Unvalid")
                        print("Not a valid directory")
                elif func == "DELETE":
                    # Gets a directory from the user and sends it
                    # Gets a message from the server if the file was deleted
                    directory = raw_input("What file would you like to delete?"
                                          " (include full path)\n")
                    if directory:  # Checks if the input wasn't just 'enter'
                        directory = directory.replace("\\", "\\\\")
                        my_socket.send('{:0>3}'.format(str(len(directory))) +
                                       directory)
                        isdir = my_socket.recv(6)  # protocol for the message
                        if isdir == "yesdir":
                            print("Success!")
                        else:
                            print("Not a file")
                    else:
                        my_socket.send("007Unvalid")
                        print("Not a file")
                elif func == "COPY":
                    # Gets 2 directories from the user and sends them
                    # Gets a message from the server if the file was copied
                    file1 = raw_input("What file would you like to copy?"
                                      " (include full path)\n")
                    file1 = file1.replace("\\", "\\\\")
                    file2 = raw_input("What file would you like to copy it to?"
                                      " (include full path)\n")
                    file2 = file2.replace("\\", "\\\\")
                    if file1 and file2:  # Checks if the input wasn't 'enter'
                        my_socket.send('{:0>3}'.format(str(len(file1))) +
                                       file1)
                        my_socket.send('{:0>3}'.format(str(len(file2))) +
                                       file2)
                        isdir = my_socket.recv(6)  # protocol for the message
                        if isdir == "yesdir":
                            print("Success!")
                        else:
                            print("At least one of the files isn't valid")
                    else:
                        my_socket.send("007Unvalid")
                        my_socket.send("007Unvalid")
                        print("At least one of the files isn't valid")
                elif func == "OPEN":
                    # Gets a program from the user and sends it
                    # Gets a message from the server if the file was opened
                    program = raw_input("What program would you like to open?"
                                        "\n")
                    if program:  # Checks if the input wasn't just 'enter'
                        my_socket.send('{:0>3}'.format(str(len(program))) +
                                       program)
                        isdir = my_socket.recv(6)  # protocol for the message
                        if isdir == "yesdir":
                            print("Success!")
                        else:
                            print("The program didn't open")
                    else:
                        my_socket.send("007Unvalid")
                        print("Not a program")
                elif func == "EXIT":
                    # Closes the socket
                    my_socket.close()
                else:
                    datalength = my_socket.recv(LenOfMessage)
                    print(my_socket.recv(int(datalength)))


if __name__ == '__main__':
    main()
