import socket
from PIL import ImageGrab
import base64
import glob
import os
import shutil
import subprocess

IP = '0.0.0.0'
PORT = 1728
LenOfMessage = 3   # The protocol for sending messages which length is unknown
# All messages like this will have three digits before them
# The digits indicate the length of the message
# For example, '{:0>3}'.format(str(len(message))) + message


def main():
    """
    Establishes connection with a client
    Does different tasks for different requests from the client
    Always stays online
    """
    server_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    server_socket.bind((IP, PORT))
    server_socket.listen(1)

    while True:
        try:  # Checks if the client disconnects in the middle
            client_socket, address = server_socket.accept()
            client_socket.send("017Server Is Running")
            datalength = client_socket.recv(LenOfMessage)
            data = client_socket.recv(int(datalength))
            while data != "EXIT":
                if data == "PICTURE":
                    # Takes a screenshot and encodes the picture
                    # Sends the picture 1000 characters at a time
                    # Adds " ENDING" to the final characters
                    im = ImageGrab.grab()
                    im.save(r'ServerScreen.png')
                    with open("ServerScreen.png",
                              "rb") as imageFile:
                        img = base64.b64encode(imageFile.read())
                        for i in xrange(0, len(img) - 1000, 1000):
                            client_socket.send(img[i:i + 1000])
                        client_socket.send(img[i + 1000:] + " ENDING")
                elif data == "DIRECTORY":
                    # Receives a directory from the client
                    # Checks if it exists and sends a message accordingly
                    # Sends the number of files inside the directory
                    # Then sends all the file names separately
                    length = client_socket.recv(LenOfMessage)
                    path = client_socket.recv(int(length))
                    if os.path.exists(path):
                        client_socket.send("yesdir")
                        files = glob.glob(path + "\*.*")
                        client_socket.send('{:0>3}'.format(str(len(files))))
                        for i in files:
                            client_socket.send(
                                '{:0>3}'.format(str(len(i))) + i)
                    else:
                        client_socket.send("notdir")
                elif data == "DELETE":
                    # Receives a directory from the client
                    # Checks if it exists and sends a message accordingly
                    # Deletes the file
                    length = client_socket.recv(LenOfMessage)
                    fl = client_socket.recv(int(length))
                    if os.path.exists(fl):
                        os.remove(fl)
                        client_socket.send("yesdir")
                    else:
                        client_socket.send("notdir")
                elif data == "COPY":
                    # Receives 2 directories from the client
                    # Checks if they exist and sends a message accordingly
                    # Copies the first file to the second
                    file1len = client_socket.recv(LenOfMessage)
                    file1 = client_socket.recv(int(file1len))
                    file2len = client_socket.recv(LenOfMessage)
                    file2 = client_socket.recv(int(file2len))
                    if os.path.exists(file1) and os.path.exists(file2):
                        shutil.copy(file1, file2)
                        client_socket.send("yesdir")
                    else:
                        client_socket.send("notdir")
                elif data == "OPEN":
                    # Receives a program from the client
                    # Tries to open it and sends a message accordingly
                    programlen = client_socket.recv(LenOfMessage)
                    program = client_socket.recv(int(programlen))
                    try:
                        subprocess.call(program)
                        client_socket.send("yesdir")
                    except:
                        client_socket.send("notdir")

                else:
                    client_socket.send("014Not a function")
                datalength = client_socket.recv(LenOfMessage)
                data = client_socket.recv(int(datalength))
            client_socket.close()
        except socket.error:
            print("Client disconnected abruptly")


if __name__ == '__main__':
    main()
